OpenWindow(0, 10, 10, 640, 480, "OpenGL demo")
SetWindowColor(0, RGB(200,220,200))
OpenGLGadget(0, 20, 10, WindowWidth(0)-40 , WindowHeight(0)-20)

IncludeFile "MoreFunctions.pbi"
IncludeFile "GLEXT.pbi"

Global Dim points.f(8) 
points(0)= 0.0 : points(1)= 0.5 : points(2)=0.0 
points(3)= 0.5 : points(4)= -0.5 : points(5)= 0.0
points(6)= -0.5 :  points(7)= -0.5 : points(8)= 0.0


Define vertex_shader.s
Define fragment_shader.s
Define *vbuff

;vertex shader source code
    vertex_shader = "#version 400"+#CRLF$
    vertex_shader + "in vec3 vp;"+#CRLF$
    vertex_shader + "void main() { "+#CRLF$
    vertex_shader + "gl_Position = vec4 (vp, 1.0);"+#CRLF$
    vertex_shader + "}"
           
    ;fragment shader source code
    fragment_shader = "#version 400"+#CRLF$
    fragment_shader + "out vec4 frag_colour;"+#CRLF$
    fragment_shader + "void main() {"+#CRLF$
    fragment_shader + "frag_colour = vec4 (0.5, 0.0, 0.5, 1.0);"+#CRLF$
    fragment_shader + "}"
        
    *vbuff = @vertex_shader
    *fbuff = @fragment_shader
    
glEnable_(#GL_DEPTH_TEST); // enable depth-testing
glDepthFunc_(#GL_LESS); // depth-testing interprets a smaller value as "closer"

Global vbo.i,vao.i

;=================================================================================

glGenBuffers( 1, @vbo )
glBindBuffer(#GL_ARRAY_BUFFER, vbo )
glBufferData(#GL_ARRAY_BUFFER,9 * SizeOf(float), @points(0), #GL_STATIC_DRAW)

glGenVertexArrays(1, @vao);
glBindVertexArray (vao)   ;
glEnableVertexAttribArray (0);
glBindBuffer (#GL_ARRAY_BUFFER, vbo);
glVertexAttribPointer (0, 3, #GL_FLOAT, #GL_FALSE, 0, #Null);

Global vs = glCreateShader(#GL_VERTEX_SHADER);
glShaderSource(vs, 1, @*vbuff, #Null) ;
glCompileShader(vs);
Global fs = glCreateShader(#GL_FRAGMENT_SHADER);
glShaderSource(fs, 1, @*fbuff, #Null);
glCompileShader(fs)                          ;

Global shader_programme = glCreateProgram();
glAttachShader(shader_programme, fs);
glAttachShader(shader_programme, vs);
glLinkProgram(shader_programme)     ;

Repeat
  glClear_(#GL_COLOR_BUFFER_BIT | #GL_DEPTH_BUFFER_BIT);
  glUseProgram(shader_programme)  
  glBindVertexArray(vao);
  ;draw points 0-3 from the currently bound VAO With current in-use shader
  glDrawArrays(#GL_TRIANGLES, 0, 3);
    
  ;SwapBuffers_(hdc)
  ;Delay(16)
  SetGadgetAttribute(0, #PB_OpenGL_FlipBuffers, #True)
Until WindowEvent() = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 73
; FirstLine = 16
; EnableXP